#ifndef __SUPPORT_H__
#define __SUPPORT_H__

#include <gtk/gtk.h>

/* Convenience macros for obtaining objects from UI file */
#define CH_GET_OBJECT( builder, name, type, data ) \
    data->name = type( gtk_builder_get_object( builder, #name ) )
#define CH_GET_WIDGET( builder, name, data ) \
        CH_GET_OBJECT( builder, name, GTK_WIDGET, data )

	/* Main data structure definition */
typedef struct _ChData ChData;
struct _ChData
{
  /* Widgets */
  GtkWidget *main_window;	/* Main application window */
  
  GtkWidget *cb_VID1;
  GtkWidget *cb_VID2;
  GtkWidget *cb_CTHR;
  GtkWidget *cb_ADCOVR;
  GtkWidget *cb_HLOCK;
  GtkWidget *cb_NONSTD;
  GtkWidget *cb_LSTLCK;
  
  GtkWidget *cb_L525;
  GtkWidget *cb_ACP;

  GtkWidget *cb_IVID1;
  GtkWidget *cb_IVID2;
  GtkWidget *cb_ICTHR;
  GtkWidget *cb_IADCOVR;
  GtkWidget *cb_IHLOCK;
  GtkWidget *cb_INONSTD;
  GtkWidget *cb_ILSTLCK;

  GtkWidget *cb_IL525;
  GtkWidget *cb_IACP;

  GtkWidget *cob_VideoStandard;
  GtkWidget *cb_AUTOD;
  GtkWidget *cb_SHDN;
  GtkWidget *cb_SLEEP;
  
  GtkWidget *vs_Contrast;
  GtkWidget *lb_LumaGain;
  GtkWidget *vs_Brightness;
  GtkWidget *lb_IRE;
  GtkWidget *vs_Hue;
  GtkWidget *lb_Degrees;
  GtkWidget *vs_Saturation;
  GtkWidget *lb_ChromaGain;
  
  GtkWidget *cob_VideoInputSrc;
  GtkWidget *cob_DCRestore;
  GtkWidget *cb_DigitalClampDis;
  
  GtkWidget *cob_GainADC;
  GtkWidget *cb_GainCoAGC;
  GtkWidget *cb_GainChAGC;
  GtkWidget *cb_GainADCAGC;

  GtkWidget *cob_KillThreshold;
  GtkWidget *cb_KillColour;
  GtkWidget *cb_KillBW;

  GtkWidget *cob_TestBars;
  GtkWidget *cob_TestTiming;
  GtkWidget *cb_TestADC;
  GtkWidget *cb_TestPattern;

  GtkWidget *cob_ClockClip;
  GtkWidget *cob_ClockOsz;
  GtkWidget *cb_ClockInvLLC;
  GtkWidget *cb_ClockSync;
  GtkWidget *cb_ClockDisableDx;
  GtkWidget *cb_ClockDisableLLC;

  GtkWidget *cob_PLLClock;
  GtkWidget *cob_PLLTracking;
  GtkWidget *cb_PLL;

  GtkWidget *cb_MiscAGC;
  GtkWidget *vs_MiscSSLICE;
};

#endif
